#include "peeker.h"

extern int _fastcall doswap (char far *, char far *);

char * _fastcall myfgets (char *str,size_t num,int handle);
int cdecl     ffprintf (int handle,char *string,...);
void          hitreturn(void);
void _fastcall   cls (void);
char _fastcall   inkey (void);
char _fastcall   carrchk (void);
char _fastcall   fossil (char function, char arg);
char _fastcall   printm (char *text);
char * _fastcall stripcr(char *);
void cdecl    deinitialize (void);
char *        genin (char length,char password,char caps,char hot,char type);
ulong _fastcall  getxbbstime(void);
char *        fidodate(void);
char *        getdttm(void);
char _fastcall   specialkey(char);
char          view (int,char *);
void          filesbbs(char *);
void          extract(char *);
void _fastcall   killall(void);
int  _fastcall   findfile(char *,char *);
int  cdecl    break_handler(void);
char _fastcall   readtext(char *,char *,int,char);
char _fastcall   printg(char *);
char _fastcall   skip_blanks(int fp);
char _fastcall   checkarchivers(char *);
void          chat(void);
void          printinfo(void);
void cdecl    bugprint(char *,...);
void _fastcall   spawnit(char *);
int  cdecl    printfm(char *,...);
char * _fastcall stristr(char *,char *);
char _fastcall   first_non_white (char *a);
int _fastcall    _wherex (void);
int _fastcall    _wherey (void);
void _fastcall   _sleep (int secs);
void _fastcall   cursor (int x, int y);
void _fastcall   curr_cursor (int *x, int *y);
char * _fastcall avatar2ansi (int avatarcode);
char * _fastcall assign (char *d,char *a);
char * _fastcall add_backslash (char *d);
void _fastcall   stat_line (void);
void _fastcall   time_line (void);
extern void _fastcall   (*pause_mtask)(void);
int _fastcall ansi_out(char *str);

struct _archiver {
    char ext[5];
    char move[41];
    char extract[41];
    char list[41];
    char error[41];
    char aname[13];
    char ename[13];
    char id[25];
    char pick[2];
    int  skip;
    int  errline;
};

extern struct _archiver *archiver;

struct _directories {
    char *path;
    char *name;
};

extern struct _directories *dirs[200];

extern char   last_file[13];
extern char   graphics;
extern word   timelimit;
extern word   baud;
extern char   pauser;
extern char   numlines;
extern word   lines;
extern int    seclvl;
extern ulong  startt;
extern char   commport;
extern struct time starter;
extern struct ffblk filestat;
extern union  REGS rg;
extern char   *directory;
extern char   *flsearch;
extern char   *xtract_dir;
extern char   *home_dir;
extern char   files_bbs[13];
extern char   jumped;
extern char   tmpnm[7];
extern char   exok;
extern char   fbbs;
extern char   help;
extern char   exitstuff;
extern char   username[36];
extern char   width;
extern char   track_dls;
extern char   chatting;
extern char   chatted;
extern char   numarcs;
extern char   numdirs;
extern char   debug;
extern char   *ctlfile;
extern char   *reader;
extern char   limittries;
extern char   *peek_now;
extern char   useswapdisk;
extern char   LIMEMS;
extern char   swap;
extern char   buffer[256];
extern long   maxarc;
extern long   totalsize;
extern char   building;
extern char   swapname[13];
extern char   cleanup;
extern int    colors[];



char _fastcall readtext (char *s,char *t,int type,char paged) {

    long place;
    struct stat filestat;
    char dostring[183];
    char eoff=0;
    word page;
    char a;
    long *pos;
    word scratch;
    int  fp;
    register int x;
    char prev=0;
    char *p;
    char *tempo;
    char *here;
    char temp='N';
    char lastpage=0;
    char searchstring[41];
    char holdstring[41];
    char teststring[81];
    char findend=0;
    char printanyway=0;
    char linelen;
    word lines=1;


  *searchstring = 0;
  *holdstring = 0;

  if (stat(s,&filestat)) return 1;
  if (!filestat.st_size) return 1;
  if ((fp = _open(s,O_RDONLY | O_BINARY | O_DENYNONE)) == -1) return 1;
  if (type > -1) {
   if (archiver[type].skip>0) {
    for(x = 0;x < archiver[type].skip;x++) {
        if (!eof(fp)) myfgets(dostring,80,fp);
        if (stristr(dostring,archiver[type].error)!=NULL) {
            if (debug) bugprint(dostring);
            _close(fp);
            return 1;
        }
    }
    place = tell(fp);
    for (;x<archiver[type].errline;x++) if (!eof(fp)) myfgets(dostring,180,fp);
    if (stristr(dostring,archiver[type].error) != NULL) {
        if (debug) bugprint(dostring);
        _close(fp);
        return 1;
    }
    lseek(fp,place,SEEK_SET);
   }
  }
  cls();
  if(graphics) printm(avatar2ansi(colors[18]));
  page = 0;
  if (!paged) {
      printm("\r\n");
      while (!eof(fp)) {
        if (!myfgets(dostring,181,fp)) break;
        dostring[180] = 0;
        stripcr(dostring);
        strcat(dostring,"\r\n");
        printm(dostring);
        if(numlines) {
            lines++;
            if(lines > numlines + 1) {
                lines = 1;
                printm("More? (Y/n) ");
                FlushOut();
                PurgeIn();
                linelen = *genin(1,0,1,1,YESNOM);
                for (x = 0;x < 12;x++) printm(BACKSPACE);
                if (linelen == 'N') break;
            }
        }
        a = toupper(inkey());
        if (a == 'S' || a == ' ') break;
        if (a == 'P') _sleep(15);
      }
      _close(fp);
      if (numlines) if (lines > numlines - 11) hitreturn();
      return 0;
  }


  if (!baud && reader && *reader) {
    _close(fp);
    sprintf(dostring,"%s %s",reader,s);
    system(dostring);
    set_screensize(1);
    validate_cursor();
    stat_line();
    return 0;
  }


  pos=(long *)malloc((word)(sizeof(long)*1024));
  if(!pos) {
    _close(fp);
    printm("\r\n\04Out of memory\r\n");
    exit(4);
  }

  p = strchr(s,':');          /* Strip path off filename for display */
  here = strrchr(s,'\\');
  if(!p && !here) here = s;
  else if (!here) here = &p[1];
  else if (p) here = (p < here) ? &here[1] : &p[1];
  else here++;

  if (type < 0) {
      printfm(" -=-=Reading: %s=-=-  Page #%hu\r\n",here,page+1);
  }
  else printfm(" Contents of %s         Page #%hu\r\n",t,page+1);

  if(graphics) printm(avatar2ansi(colors[19]));
  if(skip_blanks(fp)) goto Abort;
  pos[0] = tell(fp);
  lines = 1;
  while (!eof(fp)) {
    if ((*searchstring && !printanyway) || findend) goto Searcher;
Domore:
    if (!myfgets(dostring,181,fp)) {
        eoff++;
        goto EEOF;
    }
    stripcr(dostring);
    while ((p = strchr(dostring,'\xc')) != NULL) memmove(p,&p[1],strlen(&p[1]) + 1);
    while ((p = strchr(dostring,'\x1b')) != NULL) memmove(p,&p[1],strlen(&p[1]) + 1);
    if (!*dostring) {
        if (prev) {
            prev = 0;
            eoff = skip_blanks(fp);
            if (eoff) goto EEOF;
            else goto Domore;
        }
        else prev++;
    }
    else prev = 0;
    dostring[79] = 0;       /* absolutely positively prevent word wrap */
    strcat(dostring,"\r\n");
    if (*searchstring) {
        strcpy(teststring,dostring);
        if (stristr(teststring,searchstring)) {
          if(graphics) printm(avatar2ansi(colors[20]));
          printm(dostring);
          if(graphics) printm(avatar2ansi(colors[19]));
          lines++;
        }
        else {
            printm(dostring);
            lines++;
        }
    }
    else {
        printm(dostring);
        lines++;
    }
    scratch = strlen(dostring) - 2;
    p = dostring;
    if (scratch < width) {
        scratch++;
    }
    if (scratch > width) {
        lines++;
    }
    a = toupper(inkey());
    if (a == 'S' || a == ' ') break;
    if (a == 'P' || a == '-') if (page) goto SkipThis;
    if (a == 'M') goto Direct;
Searcher:
    if (lastpage) goto EEOF;
    if ((a == 'N') || (*searchstring) || (findend)) {
      if (findend) {
        if (++page > 1024) page = 1;
        pos[page] = tell(fp);
      }
      place = tell(fp);
Domore1:
      while (!eof(fp)) {
Domore2:
        if (!myfgets(dostring,181,fp)) {
            eoff++;
            break;
        }
        while ((p = strchr(dostring,'\xc')) != NULL) memmove(p,&p[1],strlen(&p[1])+1);
        while ((p = strchr(dostring,'\x1b')) != NULL) memmove(p,&p[1],strlen(&p[1])+1);
        if (!strcmp(dostring,"\r\n")) {
            if (prev) {
                prev = 0;
                eoff = skip_blanks(fp);
                if (eoff) break;
                else goto Domore2;
            }
            else prev++;
        }
        else prev = 0;
        if (*searchstring) {
            if (stristr(dostring,searchstring)) {
                printanyway++;
                break;
            }
        }
        lines++;
        scratch = strlen(dostring);
        p = dostring;
        while((tempo = strchr(p,'\t')) != NULL) {
            p = tempo + 1;
            scratch += 3;
        }
        if (scratch < width) {
            scratch++;
        }
        if (scratch>width) lines++;
        if (numlines) if ((lines >= numlines - 2) || (eof(fp)) || (eoff)) break;
      }
      PurgeIn();
      eoff = skip_blanks(fp);
      if (eof(fp) || eoff || printanyway) {
        if (*searchstring && !printanyway) {
            printm("\r\nNot found...\r\n");
            goto EEOF;
        }
        lseek(fp,place,SEEK_SET);
        cls();
        if(graphics) printm(avatar2ansi(colors[21]));
        if (type < 0) {
          printfm(" -=-=Reading: %s=-=-  Page #%hu\r\n",here,page+1);
        }
        else printfm(" Contents of %s         Page #%hu\r\n",t,page+1);
        if(graphics) printm(avatar2ansi(colors[19]));
        findend = prev = eoff = 0;
        lastpage = lines = 1;
        goto Domore;
      }
      if ((*searchstring || findend) && !eoff) {
        if (++page > 1024) page = 1;
        pos[page] = place = tell(fp);
        lines = 1;
        goto Domore1;
      }
    }
EEOF:
    if (numlines) if ((lines >= numlines - 2) || (eof(fp)) || (eoff)) {
        if(eof(fp) && findend) {
            findend = 0;
            lseek(fp,pos[page],SEEK_SET);
            goto Domore;
        }
Direct:
        linelen = 0;
        prev = 0;
        eoff = skip_blanks(fp);
        if (eof(fp) || eoff) {
            if(graphics) printm(avatar2ansi(colors[22]));
            printm(" (END)");
            linelen += 6;
            if(graphics) printm(avatar2ansi(colors[23]));
            temp = 'S';
        }
        else {
            if (a == 'M' || a == 'N') goto SkipThis;
            temp = 'N';
            if(graphics) printm(avatar2ansi(colors[23]));
            printm(" [F]ind [E]nd [N]ext [M]ore");
            linelen += 27;
        }
        if (page) {
            printm(" [H]ome [P]rior");
            linelen += 15;
        }
        linelen += sprintf(dostring," [O]ver [S]top: [%c] ",temp);
        printm(dostring);
	FlushOut();
        pos[page + 1] = tell(fp);
Getitagain:
	PurgeIn();
        a = *genin(1,0,1,1,ALLL);
SkipThis:
        findend = 0;
        lastpage = 0;
        printanyway = 0;
        *searchstring = 0;
        switch (a) {
            case 'S':   goto Abort;
            case 'H':   if (!page) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        page = 0;
                        lseek(fp,0,SEEK_SET);
                        break;
            case 'E':   if (eof(fp) || eoff) {
                            printm(BACKSPACE);
                            printm("\07");
                            goto Getitagain;
                        }
                        findend++;
                        break;
            case 'F':   if (eof(fp) || eoff) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        if(graphics) printm(avatar2ansi(colors[24]));
                        printfm("\r\n Search string: [%s]\r\n  -> ",holdstring);
                        strcpy(searchstring,genin(40,0,1,0,ALLL));
                        if (!*searchstring) {
                            if (*holdstring) {
                                strcpy(searchstring,holdstring);
                                if (++page>1024) page=1;
                                pos[page]=tell(fp);
                            }
                        }
                        else strcpy(holdstring,searchstring);
                        lseek(fp,pos[page],SEEK_SET);
                        eoff=skip_blanks(fp);
                        break;
            case  0:    if (eof(fp) || eoff) goto Abort;
            case 'N':   if (eof(fp) || eoff) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        a=0;
                        if (++page>1024) page=1;
                        pos[page]=tell(fp);
                        break;
            case 'O':   lseek(fp,pos[page],SEEK_SET);
                        eoff=skip_blanks(fp);
                        break;
            case 'P':
            case '-':   if (page) {
                            lseek(fp,pos[--page],SEEK_SET);
                            eoff=skip_blanks(fp);
                            break;
                        }
                        printm(BACKSPACE);
                        printm("\x7");
                        goto Getitagain;
            case 'M':   if (eof(fp) || eoff) {
                            printm("\x7");
                            printm(BACKSPACE);
                            goto Getitagain;
                        }
                        for (x=0;x<linelen;x++) printm(BACKSPACE);
                        if(graphics) printm(avatar2ansi(colors[19]));
                        if (numlines) lines = numlines - 3;
                        goto Domore;
            default:    printm(BACKSPACE);
                        goto Getitagain;
        }
        eoff=0;
        cls();
        if(graphics) printm(avatar2ansi(colors[21]));
        if (type<0) {
          if (findend || *searchstring) strcpy(teststring,"Scanning");
          else strcpy(teststring,"Reading");
          printfm(" -=-=%s: %s=-=-  Page #%hu\r\n",teststring,here,page+1);
        }
        else printfm(" Contents of %s         Page #%hu\r\n",t,page+1);
        if(graphics) printm(avatar2ansi(colors[19]));
        lines=1;
      }
  }
Abort:
  if(pos) free(pos);
  _close(fp);
  return 0;

}



char _fastcall skip_blanks (int fp) {  /* Skips blank lines, what else? */

  ulong pos;
  char temp[81];
  char eoff=0;

  do {
    pos=tell(fp);
    if (!myfgets(temp,81,fp)) eoff++;
    stripcr(temp);
  } while ((!eoff) && (!eof(fp)) && (!*temp));
  if (!eoff && !eof(fp)) lseek(fp,pos,SEEK_SET);
  return eoff;

}



char _fastcall printg (text)

    char *text;

{

   if (graphics) return (printm(text));
   else return 0;

}




char _fastcall inkey (void) {  /* MIMICS BASIC'S INKEY$ FUNCTION */

char arg = 0;
static int check = 0;

  rg.h.ah = 11;
  int86(33,&rg,&rg);
  if (rg.h.al) {
    rg.h.ah = 8;
    int86(33,&rg,&rg);
    if (rg.h.al) return((char)(rg.h.al));
    rg.h.ah = 8;
    int86(33,&rg,&rg);
    arg = specialkey(rg.h.al);
    if (arg) return (arg);
   }

  if (baud) {
      arg = carrchk();
    if (!(arg & 1)) return (0);
     return (fossil(RECVWAIT,arg));
    }

   if (check != (int)(timelimit-(getxbbstime()/60))) {
     check = (int)(timelimit-(getxbbstime()/60));
   }

   (*pause_mtask)();
   return (0);
}


char _fastcall specialkey (char a) {

char tempause;
char middle[82];
int  drive;
char dir[MAXDIR];
char *p;
char *pp;


  tempause = pauser;
  pauser = 0;

  switch (a) {
    case 45:
       exit (0);      /* QUIT DOOR */

    case 46:                /* CHAT */
       if (!chatting) {
         chatting++;
         chat();
       }
       else chatting = 0;
       break;

    case 35:                /* HANG UP */
       DTROff();
       exit(1);

    case 36:                /* SysOp SHELL */
      printm("\r\nThe SysOp has jumped to DOS...please wait...\r\n");
      FlushOut();
      drive = getdisk();
      getcurdir(++drive,dir);
      _sleep(1);
      fossil(DEINIT,0);
      bugprint("EXIT to return to Peeker");
      if (swap) {

        struct time dos_time;

        gettime(&dos_time);
        p = getenv("COMSPEC");
        if (!p) pp = searchpath("COMMAND.COM");
        else pp = searchpath(p);
        sprintf(swapname,"%02u%02u%02uPE.EKR",dos_time.ti_hour,dos_time.ti_min,dos_time.ti_sec);
	if (doswap(pp,"") == -1) system("");
	set_screensize(1);
	validate_cursor();
	stat_line();
      }
      else {
	system("");
	set_screensize(1);
	validate_cursor();
	stat_line();
      }
      fossil(INIT,0);
      setdisk (--drive);
      strcpy(middle,"\\");
      strcat(middle,dir);
      if(chdir(middle)) {
        bugprint("Error switching dirs!");
        if(xtract_dir) free(xtract_dir);
        xtract_dir = NULL;
        exok = 0;
      }
      jumped = 1;
      stat_line();
      printm("\r\nThe SysOp has returned...please continue...\r\n");
      break;

    case 72:                /* MORE TIME */
      timelimit++;
      time_line();
      break;

    case 80:                /* LESS TIME */
      if (timelimit < 1) timelimit = 0;
      else timelimit--;
      time_line();
      break;
  }
  startt = getxbbstime();
  pauser = tempause;
  return 0;
}



void _fastcall cls (void)  /* MIMICS BASIC'S CLS FUNCTION LOCAL & REMOTE */

{

  lines = 0;

  if (graphics) {
    printm("\x1b[0m\x1b[2J");
  }
  else {
    printm("\xc");
    ansi_out("\x1b[0m\x1b[2J");
  }

  lines = 0;
}


char _fastcall fossil (function,arg)   /*  HANDLES MOST USEFUL FOSSIL CALLS */

char function;
char arg;

{
  if(!baud) return 0;
  if (function == FLUSHOUT) {
     do {
       carrchk();
       rg.h.ah=3;
       rg.x.dx=commport;
       int86(20,&rg,&rg);
     }
     while (!(rg.h.ah & 64));
     return(0);
  }

  if (function == WATCHDOG) rg.h.al = arg;
  if (function == DTR) rg.h.al = arg;
  if (function == TRANSWAIT) rg.h.al = arg;
  if (function == TRANSMIT) rg.h.al = arg;
  if (function == ONOFF) rg.h.al = arg;

  rg.x.dx=commport;
  rg.h.ah=function;
  int86(20,&rg,&rg);

  if (function == INIT) {
     if (rg.x.ax != INITOK) {
       bugprint("Fossil not responding...RTFM.");
       exit (3);
     }
     return (0);
  }
  if (function == GETSTAT) {
      arg = rg.h.ah;
      if (rg.h.al & 128) {
        arg |= 128;
        return (arg);
      }
      arg &= 127;
      return (arg);
  }
  if (function == RECVWAIT) return (rg.h.al);
  if (function == TRANSMIT) return (rg.x.ax);
  return (0);
}



char _fastcall printm (char *text) {  /*  PRINTS TO MODEM AND SCREEN */

  int x,tclr;
  char *mmore,*t;
  char *p;


  getxbbstime();

  if (text == NULL || *text == 0) return (0);

  if (baud) {
    t = text;
    while(*t) {
      CSendByte(*t);
      t++;
    }
  }

  while((p = strchr(text,'\07')) != NULL)
    memmove(p,&p[1],strlen(&p[1]) + 1);
  ansi_out(text);
  if(baud && baud < 4800) FlushOut();

  if (pauser != 1) {
     if (!pauser) {
         lines = 0;
         return 0;
     }
  }
  if (pauser == 2) return 0;
  if (pauser == 255) {
      lines++;
      return 0;
  }
  if (++lines >= (numlines - 1)) {
    pauser = lines = 0;
    printm ("More? (Y-n) ");
    FlushOut();
    PurgeOut();
    mmore = genin(1,0,1,1,YESNOM);
    printm("\r");
    if(graphics) {
      printm("\x1b[K");
    }
    else {
      printm("            \r");
    }
    if (*mmore == 'N') {
       printm ("\r\n");
       return 1;
    }
    pauser = 1;
  }

  return 0;
}


void cdecl deinitialize (void) {    /*  DEINITIALIZES FOSSIL ON EXIT */

  register word x;


  if (archiver) free (archiver);
  if (numdirs) for (x = 0;x < numdirs;x++) if (dirs[x]) free(dirs[x]);
  if (baud) fossil(FLUSHOUT,0);
  fossil (DEINIT,0);
  fcloseall();

  if(cleanup) {
    if(xtract_dir && *xtract_dir) killall();
  }

  if (home_dir && isalpha(*home_dir) && home_dir[1] == ':') {
    setdisk(toupper(*home_dir) - 'A');
    home_dir[strlen(home_dir) - 1] = 0;
    chdir(home_dir);
  }

  printm("\r\n");
  ansi_out("\x1b[0m");
  if (debug) bugprint("Peeker down...");
}


char * genin (length,password,caps,hot,type)  /* GENERIC INPUT ROUTINE */

char length;
char password;
char caps;
char hot;
char type;

{

static char input[257];
int x=0;
char one=0;
char randchr[2];

 pauser=0;
 length--;

AfterChat:

 strset(input,0);
 startt=getxbbstime();

 while ((getxbbstime()-startt)<241 || (jumped)) {

  one=inkey();
  if (one == '\r') break;

Nogo:

  if (one == 8) {
      if (x>0) {
         printm(BACKSPACE);
         input [--x]=0;
         if ((type==PHONE) && ((x==2) || (x==5))) printm(BACKSPACE);
         if ((type==DATE) && ((x==1) || (x==3))) printm(BACKSPACE);
      }
      continue;
  }
  if ((caps) || (type==YESNOQ) || (type==YESNO) || (type==YESNOM) || (type==FLE) || (type==FLEW) || (type==FLEPW) || (type==FLEP)) one=toupper(one);
  if (x <= length) {
      if (type==NAME) {
        if((!isalpha(one)) && (one!=' ') && (one!='.') && (one!='-') || (!x && one==' ')) continue;
        if ((one==' ') && (strchr(input,' ')!=NULL)) continue;
      }
      if (type==NEAT) {
        if((!isalnum(one)) && (one!=' ') || (!x && one==' ')) continue;
      }
      if ((type==NEAT) || (type==NAME)) {
        if(!x) {
            one=toupper(one);
        }
        else one=tolower(one);
      }
      if((type==NEAT) || (type==NAME)) {
        if((x>0) && ((input[x-1]==' ') || (input[x-1]=='.') || (input[x-1]=='-'))) one=toupper(one);
      }
      if ((type==SUBJECT) && (!x)) one=toupper(one);
      if ((type==SUBJECT) && (!isprint(one))) continue;
      if ((type==ALLL) && (!isprint(one))) continue;
      if ((type==ALLL) && (one==127)) one=8;
      if ((type==ALPHA) && (!isalpha(one)) && (one!=' ')) continue;
      if (((type==NUM) || (type==PHONE) || (type==DATE)) && (!isdigit(one))) continue;
      if ((type==ALPHANUM) && (!isalnum(one)) && (one!=' ')) continue;
      if (((type==YESNO) || (type==YESNOM)) && (one!='Y' && one!='N')) continue;
      if ((type==YESNOQ) && (one!='Y' && one!='N' && one!='Q')) continue;
      if (type==FLE) {
         if ((!isalnum(one)) && (!strchr("._-+=!@#$%^&<>/{}[]",one))) continue;
      }
      if (type==FLEP) {
         if ((!isalnum(one)) && (!strchr("._-+=!@#$%^&<>/\\:{}[]",one))) continue;
      }
      if (type==FLEW) {
          if ((!isalnum(one)) && (!strchr("{}[]._-+=!@#$%^&<>/?*",one))) continue;
      }
      if (type==FLEPW) {
        if ((!isalnum(one)) && (!strchr("{}[]._-+=!@#$%^&<>/?*\\:",one))) continue;
      }
      if ((type==FLE) || (type==FLEP) || (type==FLEW) || (type==FLEPW)) {
         if ((one=='.') && (strchr(input,'.')!=NULL)) continue;
      }
   }
   if (jumped>0) {
    jumped=0;
    goto AfterChat;
   }

   if ((one) && (x <= length)) {
      input[x]=one;
      input[++x]=0;
      if (type==YESNOM) {
                        return(input);
      }
      if (!password) printm(&input[x-1]);
      else {
        *randchr=random(10)+33;
        randchr[1]=0;
        printm(randchr);
      }
      if ((type==PHONE) && ((x==3) || (x==6))) printm("-");
      if ((type==DATE) && ((x==2) || (x==4))) printm("/");
AfterCtrl:
      if ((hot)&&(x >= length)) {
            return (input);
      }
      startt = getxbbstime();
   }

  }
  if (chatted) {
    chatted = 0;
    goto AfterChat;
  }
  if ((getxbbstime() - startt) > 240) {
      baud = 0;
      bugprint("User time-out...");
      exit (2);
  }
  return (input);
}


char _fastcall carrchk (void)  /* Checks for carrier */

{

   if (baud) {
     rg.x.dx = commport;
     rg.h.ah = GETSTAT;
     int86(20,&rg,&rg);
     if (!(rg.h.al & 128)) {
       _sleep(1);
       rg.x.dx = commport;
       rg.h.ah = GETSTAT;
       int86(20,&rg,&rg);
       if (!(rg.h.al & 128)) {
         DTROff();
         baud = 0;
         bugprint("Lost carrier...");
         exit (1);
       }
     }
   }
   return (rg.h.ah);
}


void filesbbs (char *files_bbs)  /* READS FILES.BBS TO MODEM & SCREEN */

{

 int  fp;
 char mask[26];
 char dupe[81];
 char str[256];
 char a;
 char *b;
 char *bb;
 char p;
 char filename[127];
 ulong start;
 char new[4];
 word register x;
 struct ffblk f;
 struct fdate {
   bit day:   5;
   bit month: 4;
   bit year:  7;
 };
 union df {
   struct fdate fd;
   int x;
 } fdf;
 struct ftime {
   bit hour: 5;
   bit min:  6;
   bit sec:  5;
 };
 union tf {
   struct ftime ft;
   int x;
 } fdt;
 char should = 0;
 long temppos;
 long pos[77];
 char page;
 word dls;
 char showcomments = 0;


 if (numdirs == 1) {
   if(directory) free(directory);
   directory = assign(directory,dirs[0]->path);
 }

 if (numdirs > 1) {
    printg("\x1b[0;1;31m");
    printm("\r\n    Pick an area:\r\n");
    printg("\x1b[0;1;35m");
    lines = 2;
    for (x = 0;x < numdirs;x++) {
        pauser = 2;
        printfm("%-4u%-32s",x+1,dirs[x]->name);
        if (x % 2) {
            pauser = 1;
            printm("\r\n");
        }
        else printm("    ");
    }
    pauser = 0;
    if (x % 2) printm("\r\n");
ReTry:
    printm(" -> ");
    page = atoi(genin(3,0,0,0,NUM));
    if (!page) return;
    if (page > (char)(numdirs)) {
        printm("\07\r\n");
        goto ReTry;
    }
    if(directory) free(directory);
    directory = assign(directory,dirs[page - 1]->path);
 }

 sprintf(filename,"%s%s",directory,files_bbs);

 fp = _open(filename,O_RDONLY | O_BINARY | O_DENYNONE);
 if (fp == -1) {
        printfm("\r\nCan't open %s\r\n",files_bbs);
        return;
 }
 if (eof(fp)) {
        bugprint("Empty FILES.BBS file");
        _close (fp);
        return;
 }

 printg("\x1b[0;1;36m");
 printm("\r\nEnter search string ([Enter]=All): ");
 strcpy(mask,genin(25,0,1,0,ALLL));

 if (!*mask) {
    cls();
    if ((!baud || baud > 300) && graphics) printm("\x1b[0;1;35m File Listing   **   Page #1\r\n");
 }
 else printm("\r\n\r\n");

 page = 0;
 pos[page] = 0;

 do {
   if ((b = myfgets(str, 80, fp)) == NULL) goto nomore;
   if(!showcomments) if(first_non_white(b) == ';') continue;
DoItOver:
   getxbbstime();
   if (*mask) {
        strcpy(dupe,str);
        if (stristr(dupe,mask) == NULL) {
            p = 0;
            goto Loop;
        }
   }
   pauser = 2;
   if(*b == ';') b++;
   if (*b && *b != ' ' && *b != '\n') if (strcspn(b," ") < 13 || strlen(b) < 13) {
     b = strtok(b," \n");
     b = strtok(0,"\0");
     while ((*b) && (*b == ' ')) memmove (b,(b + 1),strlen(b));
     stripcr(b);
     strcat(b,"\r\n");
     if (!*str) goto nomore;
     printg("\x1b[0;1;33m");
     printfm("%-12s",str);
     bb = str;
     if(*bb == ';') bb++;
     sprintf(filename,"%s%s",directory,bb);
     if(findfirst(filename,&f,0)) {
       printg("\x1b[37m");
       printm(" MISSING ");
       if (b == NULL || !*b) printm("\r\n");
       goto nomore;
     }
     fdf.x = f.ff_fdate;
     fdt.x = f.ff_ftime;
     dls = (word)fdt.x;
     if (graphics) p = printfm("\x1b[34m  %-6lu \x1b[0;2;31m%02u/%02u/%u ",f.ff_fsize,fdf.fd.month,fdf.fd.day,(fdf.fd.year+80)%100);
     else p = printfm("  %-6lu %02u/%02u/%u ",f.ff_fsize,fdf.fd.month,fdf.fd.day,(fdf.fd.year+80)%100);
     if (dls && track_dls && (stricmp(f.ff_name,"FILES.BBS"))) {
        if (dls > 1) strcpy(new,"s");
        else *new = 0;
        printg("\x1b[0;1;31m");
        if (graphics) printfm("(%u Download%s)\r\n\x1b[30C",(word)dls,new);
        else printfm("(%u Download%s)\r\n                              ",(word)dls,new);
        lines++;
     }
     if (lines >= (numlines - 3)) should++;
     printg("\x1b[0;1;32m");
     pauser = 1;
     if (b != NULL && *b && (showcomments || first_non_white(b) != ';')) {
        if (strlen(b) >= (int)(width-30)) lines++;
        p = printm(b);
     }
     else {
        if (width < 47) lines++;
        p = printm("(No Description)\r\n");
     }
     if (((a = (toupper(inkey()))) != 0) || (p)) {
         if ((a == ' ' || a == 'S') || (p)) goto Abort;
         if (a == 'P') {
              start = getxbbstime();
              a = pauser;
              pauser = 0;
	      ansi_out ("[Paused]");
	      PurgeIn();
              while ((!inkey()) && ((getxbbstime() - start) < 45));
              ansi_out("\r        \r");
              pauser = a;
         }
     }
     b = NULL;
     getxbbstime();
     temppos = tell(fp);
     if ((eof(fp)) || ((b = myfgets(str, 80, fp)) == NULL)) goto nomore;
     while ((first_non_white(b) == ';' && !showcomments) || !strncmp(b,"                              ",30)) {
        if(!showcomments) if(first_non_white(b) == ';') goto SkipComments;
        if (lines >= (numlines - 3)) should++;
        if (graphics) {
            b += 30;
            a = pauser;
            pauser = 2;
            printm("\x1b[30C");
            pauser = a;
        }
        stripcr(b);
        strcat(b,"\r\n");
        if ((p = printm(b)) != 0) goto Abort;
SkipComments:
        temppos = tell(fp);
        if (((b = myfgets(str, 80, fp)) == NULL) || (eof(fp))) break;
     }
     lseek(fp,temppos,SEEK_SET);
     b = NULL;
   }

nomore:

   p = 0;
   if (lines >= (numlines - 2)) should++;
   if (b != NULL && *b) {
    pauser = 2;
    printg("\x1b[0;1;37m");
    pauser = 1;
    stripcr(b);
    strcat(b,"\r\n");
    if ((p = printm(b)) != 0) goto Abort;
   }
Loop:
   if (eof(fp) == -1) perror("ERROR");
   if ((a = (toupper(inkey()))) != 0) {
       if ((a == ' ' || a == 'S') || (p)) {
          PurgeOut();
          PurgeIn();
          _close (fp);
          pauser = 0;
          return;
       }
       if (a == 'P') {
          start = getxbbstime();
          a = pauser;
          pauser = 0;
          ansi_out ("[Paused]");
          PurgeIn();
          while ((!inkey()) && ((getxbbstime() - start) < 45));
          ansi_out("\r        \r");
          pauser = a;
       }
  }
  if (graphics) if (!baud || baud > 1200) if (lines >= (numlines - 2) || (eof(fp)) || (should)) {
        should = pauser = 0;
        printm("\r");
        printg("\x1b[K");
        if (eof(fp)) printm("\x1b[0;1;31m (END)");
        printm("\x1b[K\x1b[0;1;33m [N]ext Page [P]revious Page [O]ver [S]top: [N] ");
        FlushOut();
        PurgeIn();
        pos[page + 1] = tell(fp);
Getitagain:
        a = *genin(1,0,1,1,ALPHA);
        switch (a) {
            case 'S':   a = 'S';
                        printm("\r");
                        goto Abort;
            case 'N':
            case   0:   if (eof(fp)) {
                            a = 'S';
                            goto Abort;
                        }
                        a = 0;
                        if (++page > 75) page = 1;
                        pos[page] = tell(fp);
                        break;
            case 'O':   lseek(fp,pos[page],SEEK_SET);
                        break;
            case 'P':
            case '-':   if (!page) {
                            printm(BACKSPACE);
                            printm("\07");
                            goto Getitagain;
                        }
                        lseek(fp,pos[--page],SEEK_SET);
                        break;
            case 'V':   if(baud) goto Default;
                        showcomments = 1 - showcomments;
                        lseek(fp,pos[page],SEEK_SET);
                        break;
            default:
Default:
                        printm(BACKSPACE);
                        goto Getitagain;
        }
        printm("\r\x1b[K\x1b[0;1;35m");
        printfm(" File Listing   **   Page #%hu\r\n",page+1);
        printm("\x1b[0;1;37m");
        pauser = 1;
      }
 } while (!eof(fp));

Abort:
 _close (fp);
 pauser = 0;
 return;

}



void chat (void) {

 char a[3];

 if(graphics) printm(avatar2ansi(colors[26]));
 printm("\r\n\r\nChat mode engaged\r\n\r\n");
 while (chatting) {
   *a = inkey();
   a[1] = 0;
   if (chatting) {
     if (*a == '\r') printm("\r\n");
     else printm(a);
   }
 }
 printm("\r\n\r\nChat mode ended\r\n\r\n");
 chatted++;
}



int cdecl printfm (char *string,...) {

 static char buffer[318];

 va_list ap;
 va_start(ap,string);
 vsprintf(buffer,string,ap);
 va_end(ap);
 return(printm(buffer));
}



char * _fastcall stripcr (char *a) {

  register int x;

  x = strlen(a);
  while (x && (a[x - 1] == '\n' || a[x-1] == '\r')) a[--x] = 0;
  return a;
}


char * _fastcall myfgets (char *str,size_t num,int handle) {

    static char *p;
    static long pos;
    static int x;


    if (eof(handle)) {
        *str = 0;
        return NULL;
    }
    pos = tell(handle);
    x = _read(handle,str,num - 1);
    if (x < 1) {
        *str = 0;
        return NULL;
    }
    str[x] = 0;
    p = str;
    while(*p && *p != '\r' && *p != '\n') p++;
    if(!*p) return str;
    if(*p == '\r') {
        *p = '\n';
        if (p[1] == '\n') {
            p++;
            *p = 0;
        }
    }
    p++;
    *p = 0;
    lseek(handle,pos + ((long)((word)p - (word)str)),SEEK_SET);
    return str;
}



int cdecl ffprintf (int handle,char *string,...) {

  va_list ap;

  va_start(ap,string);
  vsprintf(buffer,string,ap);
  va_end(ap);
  _write(handle,buffer,strlen(buffer));
  return strlen(buffer);
}



char * _fastcall stristr (char *t, char *s) {

   char *t1;
   char *s1;


   while(*t) {
      t1 = t;
      s1 = s;
      while(*s1) {
         if (toupper(*s1) != toupper(*t)) break;
         else {
            s1++;
            t++;
         }
      }
      if (!*s1) return t1;
      t = t1 + 1;
   }
   return NULL;
}


char _fastcall first_non_white (char *a) {

    char *b;

    b=a;
    while(*b && (*b == ' ' || *b == '\t')) b++;
    if(*b) return *b;
    return 0;
}


char view (int type,char *pname) {

  char directory2[99] = "";
  char s[81];
  char filename[127];
  char fname[13];
  char dostring[256];
  int register x;
  char ext[5];
  int register y;
  char *p;
  struct ffblk f;
  char didarc = 0;


  strcpy(fname,pname);
  if (xtract_dir && *xtract_dir) if (!findfirst(s,&f,0)) goto StartOver;
  if(directory) strcpy(directory2,directory);

StartOver:
  strcpy(filename,tmpnm);

Listagain:

  printm("\r\n");
  if(graphics) printm(avatar2ansi(colors[14]));
  if (readtext(filename,fname,type,1)) {
    printfm("Error reading contents of %s",fname);
    printm("...may not be an archive.\r\n");
    if ((p = strrchr(s,'.')) != NULL) strcpy(ext,&p[1]);
    if (stricmp(ext,"COM") && stricmp(ext,"BIN") && stricmp(ext,"SYS") && stricmp(ext,"EXE")) {
        printm("\r\nShall I try to read it? (y-N) ");
        if(*genin(1,1,1,1,YESNO) == 'Y') {
            sprintf(dostring,"%s%s",directory2,fname);
            readtext(dostring,fname,-1,1);
        }
        printm("\r\n");
    }
    unlink(tmpnm);
    killall();
    return 1;
  }

AskAgain:

  if(graphics) printm(avatar2ansi(colors[15]));
  printm("\r\nWould you like to view a file in the archive? (y-N) ");
  if (*genin(1,0,1,1,YESNO) != 'Y') {
    unlink(tmpnm);
    return 0;
  }
  printm("\r\nName of file to view? ");
  strcpy (s,genin(12,0,1,0,FLE));
  if (!*s) goto Relist;
  *ext = 0;
  if ((p = strrchr(s,'.')) != NULL) strcpy(ext,&p[1]);
  if ((!stricmp(ext,"COM")) || (!stricmp(ext,"BIN")) || (!stricmp(ext,"SYS")) || (!stricmp(ext,"EXE") && (!xtract_dir || !*xtract_dir))) {
    printm("\r\nNot readable by humans.\r\n");
    goto AskAgain;
  }
  if (!findfirst(s,&filestat,0)) {
    printm("\r\nSorry, I already have a file by that name.\r\n");
    goto AskAgain;
  }
  if(graphics) printm(avatar2ansi(colors[16]));
  if (!checkarchivers(archiver[type].ename)) goto Relist;
  printm("\r\nHang on, extracting file...\r\n");
  *dostring = 0;
  sprintf(dostring,"%s %s%s %s",archiver[type].extract,directory2,fname,s);
  spawnit(dostring);
  printm("\r\n");

  if (!findfirst(s,&f,0) && xtract_dir && *xtract_dir) {
     for(x = 0;x < numarcs;x++) if (!stricmp(ext,archiver[x].ext)) break;
     if (x == numarcs) goto NotAnArc;
     if (!checkarchivers(archiver[x].aname)) goto NotAnArc;
     type = x;
     strcpy(fname,s);
     *directory2 = 0;
     didarc++;
     sprintf(dostring,"%s %s > %s",archiver[x].list,fname,tmpnm);
     printm("\r\nHold on, getting contents...");
     if (debug) bugprint(dostring);
     system(dostring);
     set_screensize(1);
     validate_cursor();
     stat_line();
     printm("\r");
     if(graphics) {
       printm("\x1b[K");
     }
     else {
       printm("                            ");
       CSendByte('\r');
       ansi_out("\r");
     }
     goto Listagain;
  }
NotAnArc:
  if (readtext(s,NULL,-1,1)) {
     printm("\r\nAttempt failed.\r\n");
     if (!didarc) {
         unlink(s);
         goto Relist;
     }
     unlink(tmpnm);
     return 0;
  }
  ansi_out("\x1b[0m");
  if(graphics) printm(avatar2ansi(colors[17]));
  if (!didarc) unlink(s);

Relist:

  printm("\r\nWould you like to re-list the archive's contents? (y-N) ");
  if (*genin(1,0,1,1,YESNO) == 'Y') goto StartOver;
  goto AskAgain;
}
